# apps/smtp/smtp.h File Reference

## Detailed Description

SMTP header file.

Author:
  Adam Dunkels <adam@dunkels.com>

Definition in file smtp.h.

`#include "uipopt.h"`

Go to the source code of this file.

## Data Structures

struct | smtp_state

## Appication specific configurations

An uIP application is implemented using a single application function that is called by uIP whenever a TCP/IP event occurs. The name of this function must be registered with uIP at compile time using the UIP_APPCALL definition.

uIP applications can store the application state within the uip_conn structure by specifying the type of the application structure by typedef:ing the type uip_tcp_appstate_t and uip_udp_appstate_t.

The file containing the definitions must be included in the uipopt.h file.

The following example illustrates how this can look.

    void httpd_appcall(void);
    #define UIP_APPCALL     httpd_appcall

    struct httpd_state {
      u8_t state;
      u16_t count;
      char *dataptr;
      char *script;
    };
    typedef struct httpd_state uip_tcp_appstate_t

#define | UIP_APPCALL smtp_appcall
| The name of the application function that uIP should call in response to TCP/IP events.
typedef smtp_state | uip_tcp_appstate_t
| The type of the application state that is to be stored in the uip_conn structure.

## Defines

#define | SMTP_ERR_OK 0
| Error number that signifies a non-error condition.
#define | SMTP_SEND(to, cc, from, subject, msg) smtp_send(to, cc, from, subject, msg, strlen(msg))

## Functions

void | smtp_done (unsigned char error)
| Callback function that is called when an e-mail transmission is done.
void | smtp_init (void)
void | smtp_appcall (void)